connect /

drop tablespace tde_test including contents and datafiles;
alter system set encryption wallet close;
/*
drop table stage;
create table stage as select object_name from all_objects;
*/

set echo on

clear screen
!cat $ORACLE_HOME/network/admin/sqlnet.ora
pause

clear screen
rem ALTER SYSTEM SET ENCRYPTION KEY identified by foobar;
ALTER SYSTEM SET ENCRYPTION WALLET OPEN IDENTIFIED BY foobar;
pause


clear screen
create tablespace tde_test
datafile '/tmp/tde_test.dbf' size 15m
autoextend on next 1m;
pause


drop table t;
clear screen
create table t
( c1 varchar2(30),
  c2 varchar2(30) ENCRYPT
)
tablespace tde_test;

pause
clear screen
insert into t values 
( 'this_is_NOT_encrypted', 
  'this_is_encrypted' );
commit;
pause


clear screen
select * from t;
pause


clear screen
alter system set encryption wallet close;
pause

clear screen
select c1 from t;
select c2 from t;
pause


clear screen
alter system set encryption wallet open identified by foobar;
select * from t;
pause


clear screen

alter system checkpoint;
pause
clear screen;
!strings -a /tmp/tde_test.dbf | grep 'this_is'
pause


clear screen
declare
    l_start number;
begin
    execute immediate 'truncate table t';
    l_start := dbms_utility.get_cpu_time;
    insert into t (c1)
	select object_name 
	  from stage;
    dbms_output.put_line( (dbms_utility.get_cpu_time-l_start) || ' hsecs' );
end;
/
/
pause
clear screen
exec show_space( 'T' )
pause


clear screen
declare
    l_start number;
begin
    execute immediate 'truncate table t';
    l_start := dbms_utility.get_cpu_time;
    insert into t (c2)
	select object_name 
	  from stage;
    dbms_output.put_line( (dbms_utility.get_cpu_time-l_start) || ' hsecs' );
end;
/
/
pause
clear screen
exec show_space( 'T' )
pause

clear screen
truncate table t;
insert into t select object_name, object_name from stage;
commit;
pause

clear screen
declare
    l_start number := dbms_utility.get_cpu_time;
begin
    for x in (select c1 from t)
    loop
		null;
    end loop;
    dbms_output.put_line( (dbms_utility.get_cpu_time-l_start) || ' hsecs' );
end;
/
/
pause

clear screen
declare
    l_start number := dbms_utility.get_cpu_time;
begin
    for x in (select c2 from t)
    loop
		null;
    end loop;
    dbms_output.put_line( (dbms_utility.get_cpu_time-l_start) || ' hsecs' );
end;
/
/
pause

clear screen
exec show_space( 'T' );
pause

clear screen
create index t_c2_idx on t(c2);
alter table t modify c2 encrypt no salt;
alter table t move;
create index t_c2_idx on t(c2);
create index t_c1_idx on t(c1);
begin
dbms_stats.gather_table_stats
( user, 'T', estimate_percent => 100,
  method_opt=>'for all indexed columns size 254' );
end;
/
pause

clear screen
exec show_space( 'T' );
pause

column PLAN_TABLE_OUTPUT format a100 truncate
set autotrace traceonly explain
clear screen
select * from t where c1 = 'ALL_OBJECTS';
pause

clear screen
select * from t where c2 = 'ALL_OBJECTS';
pause


clear screen
select /*+ index( t t_c1_idx )*/ * from t where c1 like 'ALL_OBJECT%';
pause

clear screen
select /*+ index( t t_c2_idx )*/ * from t where c2 like 'ALL_OBJECT%';
pause
